=== src/addons/score-addon-ltc/3rdparty/libltc/debian/changelog ===
libltc (1.3.2-1) unstable; urgency=low

  * Robin's private package. see ../ChangeLog
  * official debian package at 
    http://anonscm.debian.org/gitweb/?p=pkg-multimedia/libltc.git

 -- Robin Gareus <robin@gareus.org>  Sun, 04 Sep 2022 17:16:33 +0200

libltc (1.0.1-1) unstable; urgency=low

  * Initial release. (Closes: #692102).

 -- Jaromír Mikeš <mira.mikes@seznam.cz>  Sat, 03 Nov 2012 12:20:55 +0100
